(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
            Port[$3F2] = Octet d'tat des lecteurs de disquettes            
                                                                            
         Ŀ          
          Bit  Description                                               
         Ĵ          
          0-1  Selecteur de lecteur : 0=A, 1=B, 2=C, 3=D                 
           2   =1 -> FDC on (reset)                                      
               =0 -> hold FDC at reset                                   
           3   Etat du DMA (ON/off)                                      
           4   Etat de la del du lecteur "A" (Allume/teinte)           
           5   Etat de la del du lecteur "B" (Allume/teinte)           
           6   Etat de la del du lecteur "C" (Allume/teinte)           
           7   Etat de la del du lecteur "D" (Allume/teinte)           
                   
                                                                            
     Adresse 0040h:0017h = Etat des touches 'drapeau' du clavier            
                                                                            
         Ŀ          
          Bit  Description                                               
         Ĵ          
           0   Majuscule droit (Left shift) actif ?                      
           1   Majuscule gauche (Right shift) actif ?                    
           2   Un ou deux touche(s) contrle (Ctrl) actif ?              
           3   Un ou deux touche(s) alternate (Alt/AltGr)                
               actif ?                                                   
           4   Etat de la DEL du dfilement                              
           5   Etat de la DEL du pav numrique                          
           6   Etat de la DEL du majuscule                               
           7   Etat du mode insertion/remplacement                       
                   
                                                                            
*)

uses Clavier,EcranTxt,FaitPaus;

const
  DisqueCtrl = $03F2;

  on = TRUE; off = FALSE;

  Ani : array[0..3] of array[0..2] of boolean =
 ((ON,off,off),
  (off,ON,off),
  (off,off,ON),
  (off,ON,off));

var
  EtatClavier: byte absolute $0040:$0017;
  SavNum,SavCaps,SavScroll , N,C,S: boolean;
  SauveDisque : byte;
  i: byte; vram : word;

Procedure LitDelClav (var Num,Caps,Scroll : boolean); begin
  Scroll := (EtatClavier and $10 > 0);
  Num    := (EtatClavier and $20 > 0);
  Caps   := (EtatClavier and $40 > 0);
end;

Procedure ChangeDelClav (Num,Caps,Scroll : boolean); begin
  if Scroll then EtatClavier := EtatClavier or $10 else EtatClavier := EtatClavier and not $10;
  if Num    then EtatClavier := EtatClavier or $20 else EtatClavier := EtatClavier and not $20;
  if Caps   then EtatClavier := EtatClavier or $40 else EtatClavier := EtatClavier and not $40;
end;

begin
  EffaceEcranTxt; CurseurOff;
  LitDelClav (SavNum,SavCaps,SavScroll);
  SauveDisque := Port[DisqueCtrl];

  EcriTxc (-1,11,'Regardez les DELs de votre clavier et de votre lecteur de disquette :-)',14);

  EcriTxc (39,13,'ͻ',11);
  EcriTxc (39,14,'  Num    Caps  Scroll ',11);
  EcriTxc (39,15,'                   ',11);
  EcriTxc (39,16,'ͼ',11);

  EcriTxc ( 9,13,'ͻ',11);
  EcriTxc ( 9,14,'                      ',11);
  EcriTxc ( 9,15,'  ',11);
  EcriTxc ( 9,16,'         ',11);
  EcriTxc ( 9,17,'                   ',11);
  EcriTxc ( 9,18,'ͼ',11);

  Vram := (44-1)*2 +(16-1)*160 +1; i := 0;
  repeat
    LitDelClav (N,C,S);

    ColoriH (43   ,15,1,Ord(N)+1);
    ColoriH (43+7 ,15,1,Ord(C)+1);
    ColoriH (43+14,15,1,Ord(S)+1);

    ChangeDelClav ( Ani[i,0] , Ani[i,1] , Ani[i,2] );

    if i=3 then i := 0 else inc (i);

    if Port[DisqueCtrl]=0 then begin
      Port[DisqueCtrl] := 16;  { DEL du lecteur "A" : ON }
      ColoriH (11,17,1,10);
    end else begin
      Port[DisqueCtrl] := 0;
      ColoriH (11,17,1,2);
    end;

    Pause (300);
  until TouchPresse;

  ChangeDelClav (SavNum,SavCaps,SavScroll);
  Port[DisqueCtrl] := SauveDisque;
  CurseurOn; PosXY (0,24);
end.